<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
@Component({})
export default class AdminShopProductComponent extends Vue {
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  page = 1;
  totalPage: number = 0;

  configProduct = {
    page: 1,
    limit: 5,
    search: "",
  };
  totalPageProduct: number = 0;

  dialogAddProduct = false;
  dialogDelete = false;
  dialogDeleteList = false;
  selectedAll = false;
  loadingTable = false;
  loadingTableProduct = false;
  loading = false;
  loadingId: any = "";
  editId = "";
  idxAdd: any = null;
  comboId = "";

  listCombo: any = [];
  listProduct = [];
  listAllProduct = [];
  listProductIds = [];
  listIds = [];

  mounted() {
    this.onGetListAllProduct();
    this.onGetListCombo();
  }

  async openDialogAddProduct(i: number) {
    await this.onGetListProduct();
    this.dialogAddProduct = true;
    this.idxAdd = i;
  }

  async onGetListCombo() {
    try {
      this.loadingTable = true;
      const response = await this.$api.combo.getListAdmin(this.config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listCombo = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }
  async onGetListAllProduct() {
    try {
      const response = await this.$api.product.getListAll();
      if (response.data) {
        this.listAllProduct = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListProduct() {
    try {
      this.loadingTableProduct = true;
      const response = await this.$api.product.getListAdmin(this.configProduct);
      const { page, total, totalInList, data } = response.data;
      this.totalPageProduct = Math.ceil(total / this.configProduct.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableProduct = false;
    }
  }

  addCombo() {
    this.listCombo.push({
      name: "Combo",
      listProductId: [],
    });
  }

  onAddComboToProduct() {
    this.listCombo[this.idxAdd].listProductId = this.listProductIds;
    this.listProductIds = [];
    this.configProduct.page = 1;
    this.dialogAddProduct = false;
    const findCollection = this.listCombo[this.idxAdd];
    if (findCollection._id) {
      this.onHandlerCombo(findCollection._id);
    }
  }

  async onHandlerCombo(id: any) {
    try {
      const findCombo = this.listCombo.find(
        (combo: any, i: number) => combo._id === id || i === id
      );
      this.loadingId = id;
      const { listProductId, name, _id } = findCombo;
      if (!name) {
        return this.$pushNotification.error("Combo name cannot be left blank");
      } else if (!listProductId.length) {
        return this.$pushNotification.error("Please select combo product");
      }
      const payload = {
        name,
        listProductId,
      };
      if (_id) {
        await this.$api.combo.edit(_id, payload);
        this.$pushNotification.success("Updated combo successfully");
      } else {
        await this.$api.combo.create(payload);
        this.$pushNotification.success("Created combo successfully");
      }
      this.onGetListCombo();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = null;
      this.editId = "";
    }
  }

  removeCombo(i: number) {
    this.listCombo.splice(i, 1);
  }
  openDialogDelete(id: any) {
    if (typeof id === "string") {
      this.comboId = id;
      this.dialogDelete = true;
    } else {
      this.removeCombo(id);
    }
  }
  async onDeleteCombo() {
    try {
      this.loading = true;
      await this.$api.combo.delete(this.comboId);
      this.$pushNotification.success("Deleted combo successfully");
      this.dialogDelete = false;
      this.onGetListCombo();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  openDialogDeleteListCombo() {
    if (!this.listIds.length) {
      return this.$pushNotification.success("Please select combo list");
    }
    this.dialogDeleteList = true;
  }
  async onDeleteListCombo() {
    try {
      this.loading = true;
      await this.$api.combo.deleteList(this.listIds);
      this.$pushNotification.success("Deleted list combo successfully");
      this.dialogDeleteList = false;
      this.listIds = [];
      this.selectedAll = false;
      this.onGetListCombo();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }
  convertImgProduct(id: string) {
    const findProduct: any = this.listAllProduct.find(
      (product: any) => product._id === id
    );
    if (findProduct?.coverId?.imageUrl) {
      return `${api}/${findProduct.coverId.imageUrl}`;
    }
    return "";
  }
  calcPrice(product: any) {
    let price = 0;
    if (product.variant.length) {
      return product.variant[0].price;
    }
    // if (product.variant.length) {
    // 	for (let variant of product.variant) {
    // 		price += variant.price;
    // 	}
    // } else {
    // 	return product.price;
    // }
    return price;
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListCombo();
  }

  @Watch("config.search")
  changedSearch(val: string) {
    if (!val) {
      this.onGetListCombo();
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListCombo();
  }

  @Watch("configProduct.search")
  changedSearchProduct(val: string) {
    if (!val) {
      this.onGetListProduct();
    }
  }

  @Watch("configProduct.page")
  changedPageProduct() {
    this.onGetListProduct();
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentCombo = this.listCombo
        //@ts-ignore
        .map((combo) => combo._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentCombo];
    } else {
      //@ts-ignore
      const selectedCurrentCombo = this.listCombo
        //@ts-ignore
        .map((combo) => combo._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentCombo.includes(c)
      );
    }
  }
}
</script>

<style>
.bg-img {
  background: rgba(72, 84, 91, 0.64);
  border: 1px solid #edeeef;
  border-radius: 8px;
  padding: 6px;
}
</style>
